#pragma once

// Include all necessary headers from the ADTF SDK
#include <adtffiltersdk/adtf_filtersdk.h>

// For simplicity use the necessary namespaces
using namespace adtf::util;
using namespace adtf::ucom;
using namespace adtf::base;
using namespace adtf::streaming;
using namespace adtf::filter;

// To implement a Filter we subclass adtf::filter::cFilter.
class cPropertyVariableCallbackFilter: public cFilter
{
public:
    // This macros provides some meta information about our Filter Implementation
    // This will be exposed by the plugin class factory.
    ADTF_CLASS_ID_NAME(cPropertyVariableCallbackFilter,
                       "property_variable_callback.filter.adtf_guides.cid",
                       "Property Variable Callback Filter");
public:
    // In the constructor, we setup all aspects of our Filter.
    cPropertyVariableCallbackFilter();

private:
    adtf::base::property_variable<double> m_oObservedProperty = 0.0;
};
